Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkInteractorStyleFlight Class Reference

`#include <vtkInteractorStyleFlight.h>`

Inheritance diagram for vtkInteractorStyleFlight:

[legend]
Collaboration diagram for vtkInteractorStyleFlight:

[legend]
List of all members.

## Detailed Description

provides flight motion routines

Date:
  2002/07/12 18:24:43

Revision:
  1.20

Left mouse button press produces forward motion. Right mouse button press produces reverse motion. Moving mouse during motion steers user in desired direction. Keyboard controls are: Left/Right/Up/Down Arrows for steering direction 'A' forward, 'Z' reverse motion Ctrl Key causes sidestep instead of steering in mouse and key modes Shift key is accelerator in mouse and key modes Ctrl and Shift together causes Roll in mouse and key modes

By default, one "step" of motion corresponds to 1/250th of the diagonal of bounding box of visible actors, '+' and '-' keys allow user to increase or decrease step size.

Events:
  vtkCommand::InteractionEvent

Created by:
  - Biddiscombe, John

CVS contributions (if > 5%):
  - Biddiscombe, John (52%)
  - Barre, Sebastien (34%)
  - Davis, Jon (9%)

CVS logs (CVSweb):
  - .`cxx` (`/Rendering/vtkInteractorStyleFlight.cxx)`
  - .`h` (`/Rendering/vtkInteractorStyleFlight.h)`

Examples:
  vtkInteractorStyleFlight (Examples)

Definition at line 67 of file vtkInteractorStyleFlight.h.

## [NOHEADER]
void | UpdateSteering (vtkCamera *cam)
void | UpdateMouseSteering (vtkCamera *cam)
void | FlyByMouse (vtkCamera *cam)
void | FlyByKey (vtkCamera *cam)
void | GetLRVector (double vector[3], vtkCamera *cam)
void | MotionAlongVector (double vector[3], double amount, vtkCamera *cam)
void | SetupMotionVars (vtkCamera *cam)
void | FinishCamera (vtkCamera *cam)
unsigned char | KeysDown
int | DisableMotion
int | RestoreUpVector
double | DiagonalLength
double | MotionStepSize
double | MotionUserScale
double | MotionAccelerationFactor
double | AngleStepSize
double | AngleAccelerationFactor
double | DefaultUpVector [3]
double | AzimuthStepSize
double | IdealFocalPoint [3]
vtkPerspectiveTransform * | Transform
double | DeltaYaw
double | lYaw
double | DeltaPitch
double | lPitch
## Public Types
typedef vtkInteractorStyle | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | JumpTo (double campos[3], double focpos[3])
virtual double * | GetDefaultUpVector ()
virtual void | GetDefaultUpVector (double data[3])
virtual void | SetDefaultUpVector (double data[])
virtual void | SetMotionStepSize (double)
virtual double | GetMotionStepSize ()
virtual void | SetMotionAccelerationFactor (double)
virtual double | GetMotionAccelerationFactor ()
virtual void | SetAngleStepSize (double)
virtual double | GetAngleStepSize ()
virtual void | SetAngleAccelerationFactor (double)
virtual double | GetAngleAccelerationFactor ()
virtual void | SetDisableMotion (int)
virtual int | GetDisableMotion ()
virtual void | DisableMotionOn ()
virtual void | DisableMotionOff ()
virtual void | SetRestoreUpVector (int)
virtual int | GetRestoreUpVector ()
virtual void | RestoreUpVectorOn ()
virtual void | RestoreUpVectorOff ()
virtual void | OnMouseMove ()
virtual void | OnLeftButtonDown ()
virtual void | OnLeftButtonUp ()
virtual void | OnMiddleButtonDown ()
virtual void | OnMiddleButtonUp ()
virtual void | OnRightButtonDown ()
virtual void | OnRightButtonUp ()
virtual void | OnChar ()
virtual void | OnKeyDown ()
virtual void | OnKeyUp ()
virtual void | OnTimer ()
virtual void | ForwardFly ()
virtual void | ReverseFly ()
virtual void | StartForwardFly ()
virtual void | EndForwardFly ()
virtual void | StartReverseFly ()
virtual void | EndReverseFly ()
## Static Public Methods
vtkInteractorStyleFlight * | New ()
int | IsTypeOf (const char *type)
vtkInteractorStyleFlight * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkInteractorStyleFlight ()
| ~vtkInteractorStyleFlight ()
## Protected Attributes
CPIDControl * | PID_Yaw
CPIDControl * | PID_Pitch

## Member Typedef Documentation

typedef vtkInteractorStyle vtkInteractorStyleFlight::Superclass

| Reimplemented from vtkInteractorStyle. Definition at line 71 of file vtkInteractorStyleFlight.h.

## Constructor & Destructor Documentation

vtkInteractorStyleFlight::vtkInteractorStyleFlight | ( |  | ) | `[protected]`

vtkInteractorStyleFlight::~vtkInteractorStyleFlight | ( |  | ) | `[protected]`

## Member Function Documentation

vtkInteractorStyleFlight* vtkInteractorStyleFlight::New | ( |  | ) | `[static]`

| This class must be supplied with a vtkRenderWindowInteractor wrapper or parent. This class should not normally be instantiated by application programmers. Reimplemented from vtkInteractorStyle.

virtual const char* vtkInteractorStyleFlight::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkInteractorStyle.

int vtkInteractorStyleFlight::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkInteractorStyle.

virtual int vtkInteractorStyleFlight::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkInteractorStyle.

vtkInteractorStyleFlight* vtkInteractorStyleFlight::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkInteractorStyle.

void vtkInteractorStyleFlight::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkInteractorStyle.

void vtkInteractorStyleFlight::JumpTo | ( | double | campos[3],
|  | double | focpos[3]
| ) |

| Move the Eye/Camera to a specific location (no intermediate steps are taken

virtual void vtkInteractorStyleFlight::SetMotionStepSize | ( | double |  | ) | `[virtual]`

| Set the basic unit step size : by default 1/250 of bounding diagonal

virtual double vtkInteractorStyleFlight::GetMotionStepSize | ( |  | ) | `[virtual]`

| Set the basic unit step size : by default 1/250 of bounding diagonal

virtual void vtkInteractorStyleFlight::SetMotionAccelerationFactor | ( | double |  | ) | `[virtual]`

| Set acceleration factor when shift key is applied : default 10

virtual double vtkInteractorStyleFlight::GetMotionAccelerationFactor | ( |  | ) | `[virtual]`

| Set acceleration factor when shift key is applied : default 10

virtual void vtkInteractorStyleFlight::SetAngleStepSize | ( | double |  | ) | `[virtual]`

| Set the basic angular unit for turning : default 1 degree

virtual double vtkInteractorStyleFlight::GetAngleStepSize | ( |  | ) | `[virtual]`

| Set the basic angular unit for turning : default 1 degree

virtual void vtkInteractorStyleFlight::SetAngleAccelerationFactor | ( | double |  | ) | `[virtual]`

| Set angular acceleration when shift key is applied : default 5

virtual double vtkInteractorStyleFlight::GetAngleAccelerationFactor | ( |  | ) | `[virtual]`

| Set angular acceleration when shift key is applied : default 5

virtual void vtkInteractorStyleFlight::SetDisableMotion | ( | int |  | ) | `[virtual]`

| Disable motion (temporarily - for viewing etc)

virtual int vtkInteractorStyleFlight::GetDisableMotion | ( |  | ) | `[virtual]`

| Disable motion (temporarily - for viewing etc)

virtual void vtkInteractorStyleFlight::DisableMotionOn | ( |  | ) | `[virtual]`

| Disable motion (temporarily - for viewing etc)

virtual void vtkInteractorStyleFlight::DisableMotionOff | ( |  | ) | `[virtual]`

| Disable motion (temporarily - for viewing etc)

virtual void vtkInteractorStyleFlight::SetRestoreUpVector | ( | int |  | ) | `[virtual]`

| When flying, apply a restorative force to the "Up" vector. This is activated when the current 'up' is close to the actual 'up' (as defined in DefaultUpVector). This prevents excessive twisting forces when viewing from arbitrary angles, but keep the horizon level when the user is flying over terrain.

virtual int vtkInteractorStyleFlight::GetRestoreUpVector | ( |  | ) | `[virtual]`

| When flying, apply a restorative force to the "Up" vector. This is activated when the current 'up' is close to the actual 'up' (as defined in DefaultUpVector). This prevents excessive twisting forces when viewing from arbitrary angles, but keep the horizon level when the user is flying over terrain.

virtual void vtkInteractorStyleFlight::RestoreUpVectorOn | ( |  | ) | `[virtual]`

| When flying, apply a restorative force to the "Up" vector. This is activated when the current 'up' is close to the actual 'up' (as defined in DefaultUpVector). This prevents excessive twisting forces when viewing from arbitrary angles, but keep the horizon level when the user is flying over terrain.

virtual void vtkInteractorStyleFlight::RestoreUpVectorOff | ( |  | ) | `[virtual]`

| When flying, apply a restorative force to the "Up" vector. This is activated when the current 'up' is close to the actual 'up' (as defined in DefaultUpVector). This prevents excessive twisting forces when viewing from arbitrary angles, but keep the horizon level when the user is flying over terrain.

virtual double* vtkInteractorStyleFlight::GetDefaultUpVector | ( |  | ) | `[virtual]`

virtual void vtkInteractorStyleFlight::GetDefaultUpVector | ( | double | data[3] | ) | `[virtual]`

virtual void vtkInteractorStyleFlight::SetDefaultUpVector | ( | double | data[] | ) | `[virtual]`

virtual void vtkInteractorStyleFlight::OnMouseMove | ( |  | ) | `[virtual]`

| Concrete implementation of Mouse event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::OnLeftButtonDown | ( |  | ) | `[virtual]`

| Concrete implementation of Mouse event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::OnLeftButtonUp | ( |  | ) | `[virtual]`

| Concrete implementation of Mouse event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::OnMiddleButtonDown | ( |  | ) | `[virtual]`

| Concrete implementation of Mouse event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::OnMiddleButtonUp | ( |  | ) | `[virtual]`

| Concrete implementation of Mouse event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::OnRightButtonDown | ( |  | ) | `[virtual]`

| Concrete implementation of Mouse event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::OnRightButtonUp | ( |  | ) | `[virtual]`

| Concrete implementation of Mouse event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::OnChar | ( |  | ) | `[virtual]`

| Concrete implementation of Keyboard event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::OnKeyDown | ( |  | ) | `[virtual]`

| Concrete implementation of Keyboard event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::OnKeyUp | ( |  | ) | `[virtual]`

| Concrete implementation of Keyboard event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::OnTimer | ( |  | ) | `[virtual]`

| Concrete implementation of Keyboard event bindings for flight Reimplemented from vtkInteractorStyle.

virtual void vtkInteractorStyleFlight::ForwardFly | ( |  | ) | `[virtual]`

| Concrete implementation of Keyboard event bindings for flight

virtual void vtkInteractorStyleFlight::ReverseFly | ( |  | ) | `[virtual]`

| Concrete implementation of Keyboard event bindings for flight

virtual void vtkInteractorStyleFlight::StartForwardFly | ( |  | ) | `[virtual]`

| Concrete implementation of Keyboard event bindings for flight

virtual void vtkInteractorStyleFlight::EndForwardFly | ( |  | ) | `[virtual]`

| Concrete implementation of Keyboard event bindings for flight

virtual void vtkInteractorStyleFlight::StartReverseFly | ( |  | ) | `[virtual]`

| Concrete implementation of Keyboard event bindings for flight

virtual void vtkInteractorStyleFlight::EndReverseFly | ( |  | ) | `[virtual]`

| Concrete implementation of Keyboard event bindings for flight

void vtkInteractorStyleFlight::UpdateSteering | ( | vtkCamera * | cam | ) | `[protected]`

| Routines used internally for computing motion and steering

void vtkInteractorStyleFlight::UpdateMouseSteering | ( | vtkCamera * | cam | ) | `[protected]`

| Routines used internally for computing motion and steering

void vtkInteractorStyleFlight::FlyByMouse | ( | vtkCamera * | cam | ) | `[protected]`

| Routines used internally for computing motion and steering

void vtkInteractorStyleFlight::FlyByKey | ( | vtkCamera * | cam | ) | `[protected]`

| Routines used internally for computing motion and steering

void vtkInteractorStyleFlight::GetLRVector | ( | double | vector[3],
|  | vtkCamera * | cam
| ) | `[protected]`

| Routines used internally for computing motion and steering

void vtkInteractorStyleFlight::MotionAlongVector | ( | double | vector[3],
|  | double | amount,
|  | vtkCamera * | cam
| ) | `[protected]`

| Routines used internally for computing motion and steering

void vtkInteractorStyleFlight::SetupMotionVars | ( | vtkCamera * | cam | ) | `[protected]`

| Routines used internally for computing motion and steering

void vtkInteractorStyleFlight::FinishCamera | ( | vtkCamera * | cam | ) | `[protected]`

| Routines used internally for computing motion and steering

## Member Data Documentation

unsigned char vtkInteractorStyleFlight::KeysDown`[protected]`

| Routines used internally for computing motion and steering Definition at line 167 of file vtkInteractorStyleFlight.h.

int vtkInteractorStyleFlight::DisableMotion`[protected]`

| Routines used internally for computing motion and steering Definition at line 168 of file vtkInteractorStyleFlight.h.

int vtkInteractorStyleFlight::RestoreUpVector`[protected]`

| Routines used internally for computing motion and steering Definition at line 169 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::DiagonalLength`[protected]`

| Routines used internally for computing motion and steering Definition at line 170 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::MotionStepSize`[protected]`

| Routines used internally for computing motion and steering Definition at line 171 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::MotionUserScale`[protected]`

| Routines used internally for computing motion and steering Definition at line 172 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::MotionAccelerationFactor`[protected]`

| Routines used internally for computing motion and steering Definition at line 173 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::AngleStepSize`[protected]`

| Routines used internally for computing motion and steering Definition at line 174 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::AngleAccelerationFactor`[protected]`

| Routines used internally for computing motion and steering Definition at line 175 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::DefaultUpVector[3]`[protected]`

| Routines used internally for computing motion and steering Definition at line 176 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::AzimuthStepSize`[protected]`

| Routines used internally for computing motion and steering Definition at line 177 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::IdealFocalPoint[3]`[protected]`

| Routines used internally for computing motion and steering Definition at line 178 of file vtkInteractorStyleFlight.h.

vtkPerspectiveTransform* vtkInteractorStyleFlight::Transform`[protected]`

| Routines used internally for computing motion and steering Definition at line 179 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::DeltaYaw`[protected]`

| Routines used internally for computing motion and steering Definition at line 180 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::lYaw`[protected]`

| Routines used internally for computing motion and steering Definition at line 181 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::DeltaPitch`[protected]`

| Routines used internally for computing motion and steering Definition at line 182 of file vtkInteractorStyleFlight.h.

double vtkInteractorStyleFlight::lPitch`[protected]`

| Routines used internally for computing motion and steering Definition at line 183 of file vtkInteractorStyleFlight.h.

CPIDControl* vtkInteractorStyleFlight::PID_Yaw`[protected]`

| Definition at line 186 of file vtkInteractorStyleFlight.h.

CPIDControl* vtkInteractorStyleFlight::PID_Pitch`[protected]`

| Definition at line 187 of file vtkInteractorStyleFlight.h.

The documentation for this class was generated from the following file:

- Rendering/vtkInteractorStyleFlight.h